package openchat.cliente;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.io.*;
import java.net.*;
import java.util.*;

public class ClienteOpenChat
{
        private int UsuarioID;
	private String UsuarioSenha, HostServer;
	private int PortServer, PortClient;
			
	public ClienteOpenChat()//String HostServer, int PortServer, int PortClient)
	{/*
		this.PortServer = PortServer;
		this.HostServer = HostServer;
		this.PortClient = PortClient;
	*/	
		try
		{			
			LoginUsuario L = new LoginUsuario();//HostServer,PortServer,PortClient);
			L.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		}
		catch(Exception Server)	
		{
			JOptionPane.showMessageDialog(null,"Error in create the local Client, change the Port: [ 127.0.0.1 : "+PortClient+" ]");
			System.out.println(Server.getMessage());
			System.exit(0);
		}
	}
}

class LoginUsuario extends JFrame
{
	private JLabel LabelId,Pass,Hello;
	private JTextField Id;
	private JPasswordField Password;
	private int UsuarioID, PortServer=10000, PortClient=10001, LastId=0;
	private String UsuarioSenha, HostServer="";
	private boolean check=true;
	
	static ImageIcon iconEnter = new ImageIcon("openchat/client/icons/gnomeicu-ok.png");
	static ImageIcon iconOptions = new ImageIcon("openchat/client/icons/gnomeicu-info.png");
	static ImageIcon iconNewUser = new ImageIcon("openchat/client/icons/gnomeicu-ffc.png");
	static ImageIcon iconClose = new ImageIcon("openchat/client/icons/gnomeicu-cancel.png");
	
	public LoginUsuario()//String HS, int PS, int PC)
	{
		super("OpenChat");
	
		//this.HostServer = HS;
		//this.PortServer = PS;
		
		//this.PortClient = PC;
		
		try{
			ReadFile();
		}catch(Exception READ){}
			
		JPanel Login = new JPanel();
		Login.setLayout(new BorderLayout());
			
		Hello = new JLabel("USER IDENTIFICATION",JLabel.CENTER);
		LabelId = new JLabel("id ",JLabel.RIGHT);
		Pass = new JLabel("password ",JLabel.RIGHT);
		
		JPanel Status =  new JPanel();
		Status.setLayout( new GridLayout(2,1) );
		Login.add(Status,BorderLayout.LINE_START);
			
		Login.add(Hello,BorderLayout.NORTH);
		Status.add(LabelId);
		Status.add(Pass);
		
		JPanel L = new JPanel();
		L.setLayout(new GridLayout(2,1));
		Login.add(L,BorderLayout.CENTER);
		
		Id = new JTextField(12);
		L.add(Id);
		Id.setText(""+LastId);
		
		Password = new JPasswordField(25);
		L.add(Password);
		
		Panel Buttons = new Panel();
		Buttons.setLayout(new GridLayout(2,2));
		Login.add(Buttons,BorderLayout.PAGE_END);
		
		JButton Enter = new JButton("Enter", iconEnter);
		Buttons.add(Enter);
		
		JButton BNewUser = new JButton("New User", iconNewUser);
		Buttons.add(BNewUser);
		
		JButton Options = new JButton("Options", iconOptions);
		Buttons.add(Options);
		
		JButton Cancel = new JButton("Cancel", iconClose);
		Buttons.add(Cancel);
		
		
		ButtonHandler handler = new ButtonHandler();
		
		Enter.addActionListener(handler);
		Cancel.addActionListener(handler);
		BNewUser.addActionListener(handler);
		Options.addActionListener(handler);
		
		getContentPane().add(Login);
		
		
		setResizable(false);
		setLocation(362,317);
		setSize(300,135);
		setVisible(true);
		
		show();
	}
	
	public class ButtonHandler implements ActionListener
	{
		public void actionPerformed(ActionEvent E)
		{
			if(E.getActionCommand().equals("Enter"))
			{
				if(Id.getText().length() == 0 || Password.getPassword().length == 0 )
					JOptionPane.showMessageDialog(null,"Please, write complete.");
				else
				{
					try
					{
						UsuarioID = Integer.parseInt(Id.getText());
					}
					catch(Exception I)
					{
						JOptionPane.showMessageDialog(null,"The value of ID is invalid. (only integer)");
						return;
					}
					UsuarioSenha = (new String(Password.getPassword()));
					try
					{
						Socket MSG = new Socket(HostServer,PortServer);
						BufferedReader Reply = new BufferedReader (new InputStreamReader (MSG.getInputStream()));
						PrintWriter Send = new PrintWriter(new OutputStreamWriter(MSG.getOutputStream()));
						
						String Token = new String("###");
												
						String Message = "Login"+Token+UsuarioID+Token+UsuarioSenha+Token+PortClient;
																		
						Send.println(Message);
						Send.flush();
						
						if( (new String(Reply.readLine()).equals("false")))
							JOptionPane.showMessageDialog(null,"\n    Ops....not connect ! \n\n - The ID or Password is incorrect\n - Client now connected ?\n ","Failed",JOptionPane.ERROR_MESSAGE);
						else
						{
							Send.close();
							Reply.close();
							MSG.close();
							dispose();
							int TEMPID=0;
							if(check)
							TEMPID=UsuarioID;
							WriteFile(HostServer+"\n"+PortServer+"\n"+PortClient+"\n"+TEMPID);
							new ClientMain(HostServer,PortServer,PortClient,Integer.parseInt(Id.getText()), UsuarioSenha).start();
						}
					}
					catch(Exception Socket)
					{
						JOptionPane.showMessageDialog(null,"Error in conect to server: [ "+HostServer+" : "+PortServer+" ]\n\n"+Socket.getMessage());
						return;
					}					
				}
			}
			
			if(E.getActionCommand().equals("Cancel"))
			{
				System.exit(0);
			}
			
			if(E.getActionCommand().equals("New User"))
			{
				new NewUser(HostServer,PortServer,PortClient).start();
				
				dispose();
			}
			
			if(E.getActionCommand().equals("Options"))
			{/*
				JPanel Opts = new JPanel(new GridLayout(2,2));
				JLabel LServer = new JLabel("Server Address: ");
				JLabel LPort = new JLabel("*/
				setVisible(false);
				new ClientOptions().start();
			}
				
		}
	}
	
	public int ReturnId()
	{
		return UsuarioID;
	}
	
	public String ReturnPassword()
	{
		return UsuarioSenha;
	}
	
	class ClientOptions extends Thread
	{
		private JFrame jFrame;
		private JPanel jPanel, jButtons, L, R;
		private JButton ButtonUpdate, ButtonClose;
		private JLabel labelIpServer, labelPortServer, labelRemember, labelOptions, labelPortClient;
		private JTextField IpServer, PortS, PortC;
		private Checkbox Remember;
		
			
		public void run()
		{
			jFrame = new JFrame();
			jPanel = new JPanel(new BorderLayout());
			L = new JPanel(new GridLayout(4,1));
			R = new JPanel(new GridLayout(4,1));
			jButtons = new JPanel(new GridLayout(1,2));
			
			
			labelOptions = new JLabel("Options", JLabel.CENTER);
			labelOptions.setForeground(Color.blue);
			
			labelIpServer = new JLabel(" Ip Server ");
			labelPortServer = new JLabel(" Port Server ");
			labelPortClient = new JLabel(" Port Client ");
			labelRemember = new JLabel(" Remember last Id ");
					
			L.add(labelIpServer);
			L.add(labelPortServer);
			L.add(labelPortClient);
			L.add(labelRemember);
						
			Remember = new Checkbox("yes");
			IpServer = new JTextField();
			PortS = new JTextField();
			PortC = new JTextField();
			
			try
			{
				IpServer.setText(""+HostServer);
				PortS.setText(""+PortServer);
				PortC.setText(""+PortClient);
				Remember.setState(check);
			}
			catch(Exception NDA){}
						
			R.add(IpServer);			
			R.add(PortS);
			R.add(PortC);
			R.add(Remember);
			
			checkBox chk = new checkBox();
			Remember.addItemListener(chk);
			
			ButtonUpdate = new JButton("Update", iconEnter);
			ButtonClose = new JButton("Close", iconClose);
			jButtons.add(ButtonUpdate);
			jButtons.add(ButtonClose);
			
			ButtonHandler handler = new ButtonHandler();
			ButtonUpdate.addActionListener(handler);
			ButtonClose.addActionListener(handler);
		
			
			jPanel.add(labelOptions, BorderLayout.PAGE_START);
			jPanel.add(L, BorderLayout.LINE_START);
			jPanel.add(R, BorderLayout.CENTER);
			jPanel.add(jButtons, BorderLayout.PAGE_END);
			
			jFrame.getContentPane().add(jPanel);
			jFrame.setTitle("OpenChat - Options");
			jFrame.setResizable(false);
			jFrame.setLocation(377,321);
			jFrame.setSize(270,135);
			jFrame.setVisible(true);
			jFrame.show();
			jFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		}
		public class checkBox implements ItemListener{
			public void itemStateChanged(ItemEvent event)
			{
				check=Remember.getState();
			}
		}
		
		public class ButtonHandler implements ActionListener
		{
			public void actionPerformed(ActionEvent E)
			{
				if(E.getActionCommand().equals("Update"))
				{
					HostServer = IpServer.getText();
					PortServer = Integer.parseInt(new String (""+PortS.getText()));
					PortClient = Integer.parseInt(new String (""+PortC.getText()));
					JOptionPane.showMessageDialog(null,"Config wrote ! ( config.opc )");
					setVisible(true);
					jFrame.dispose();
										
				}
				if(E.getActionCommand().equals("Close"))
				{
					setVisible(true);
					jFrame.dispose();
				}
			}
		}
	}
	
	public void WriteFile(String Text)
	{
		boolean op = false;
		
		try
		{
			File file = new File("openchat/client/config.opc");
										
			FileWriter fWriter = new FileWriter(file, op);
			BufferedWriter out = new BufferedWriter(fWriter);
							
			out.write(Text);
			out.write('\r');
			out.write('\n');
			
			out.close();				
											
		}
		catch (IOException e)
		{
			System.out.println("Error: " + e.getMessage());
		}
		catch (SecurityException se)
		{
			System.out.println("Error: " + se.getMessage());
		}
	}	

	public boolean ReadFile()
	{
		boolean ok=false;
			
		try
		{
			File usr = new File("openchat/client/config.opc");
			FileReader file = new FileReader(usr);
			BufferedReader buffer = new BufferedReader(file);
				
			this.HostServer = buffer.readLine();
			this.PortServer = Integer.parseInt(buffer.readLine());
			this.PortClient = Integer.parseInt(buffer.readLine());
			this.LastId = Integer.parseInt(buffer.readLine());
			ok=true;
			
			buffer.close();
			
		}
		catch(IOException File)
		{
			System.out.println("Error :" + File.getMessage());
			ok=false;
		}
		return ok;
	}
			
}

class NewUser extends Thread
{
	
	private JFrame jFrame;
	private JLabel LNewUser, Label_Login, Label_Name, Label_Email, Label_City, Label_Info, Label_Password, Label_CCPassword;
	private JTextField Login, Name, Email, City, Info;
	private JPasswordField Password, CCPassword;
	private JButton Send, Cancel;
	
	private int UsuarioID, PortServer,PortClient;
	private String UsuarioSenha, HostServer, Title;
		
	static ImageIcon iconSend = new ImageIcon("openchat/client/icons/gnomeicu-ok.png");
	static ImageIcon iconCancel = new ImageIcon("openchat/client/icons/gnomeicu-cancel.png");
	
	public NewUser(String HS, int PS, int PC)
	{
		this.HostServer = HS;
		this.PortServer = PS;
		this.PortClient = PC;
	}
	
	public void run()
	{
		jFrame = new JFrame();
		JPanel Register = new JPanel();
		JPanel L = new JPanel();
		JPanel R = new JPanel();
		JPanel E = new JPanel();
		
		Register.setLayout(new BorderLayout());
		L.setLayout(new GridLayout(7,1));
		R.setLayout(new GridLayout(7,1));
		E.setLayout(new GridLayout(1,2));
		
		Register.add(L,BorderLayout.LINE_START);
		Register.add(R,BorderLayout.CENTER);
		Register.add(E,BorderLayout.PAGE_END);
		
		LNewUser = new JLabel("NEW USER - WRITE INFORMATION",JLabel.CENTER);
		Register.add(LNewUser,BorderLayout.PAGE_START);
		
		Label_Login = new JLabel(" Nick",JLabel.LEFT);
		Label_Name = new JLabel (" Name",JLabel.LEFT);
		Label_Email = new JLabel(" Email",JLabel.LEFT);
		Label_City = new JLabel (" City",JLabel.LEFT);
		Label_Info = new JLabel (" Info",JLabel.LEFT);
		Label_Password = new JLabel(" Password  ",JLabel.LEFT);
		Label_CCPassword = new JLabel(" Confirm Password  ",JLabel.LEFT);
		
		Login = new JTextField(20);
		Email = new JTextField(50);
		City = new JTextField(30);
		Name = new JTextField(100);
		Info = new JTextField(100);
		Password = new JPasswordField();
		CCPassword = new JPasswordField();
		
		Send = new JButton("Send", iconSend);
		Cancel = new JButton("Cancel", iconCancel);
		
		L.add(Label_Login);
		L.add(Label_Password);
		L.add(Label_CCPassword);
		L.add(Label_Name);
		L.add(Label_Email);
		L.add(Label_City);
		L.add(Label_Info);
				
		R.add(Login);
		R.add(Password);
		R.add(CCPassword);
		R.add(Name);
		R.add(Email);
		R.add(City);
		R.add(Info);
		
		E.add(Send);
		E.add(Cancel);
		
		ButtonHandler handler = new ButtonHandler(HostServer,PortServer);
		Send.addActionListener(handler);
		Cancel.addActionListener(handler);
				
		jFrame.getContentPane().add(Register);
		
		jFrame.setTitle("OpenChat - New User");
		jFrame.setResizable(false);
		jFrame.setLocation(312,289);
		jFrame.setSize(400,190);
		jFrame.setVisible(true);
		jFrame.show();
		jFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
	}
	
	public class ButtonHandler implements ActionListener
	{
		String HostServer, Token, Message;
		int PortServer;
		
		public ButtonHandler(String Host, int Port)
		{
			this.HostServer = Host;
			this.PortServer = Port;
		}
		
		private boolean writeComplete()
		{
			boolean resul = true;
			
			if(Login.getText().length()==0)
				resul=false;
			if(Email.getText().length()==0)
				resul=false;
			if(Name.getText().length()==0)
				resul=false;
			if(City.getText().length()==0)
				resul=false;
			if(Info.getText().length()==0)
				resul=false;
			if(new String(Password.getPassword()).length()==0)
				resul=false;
			if (!(new String(Password.getPassword()) ).equals(new String(CCPassword.getPassword())))
				resul=false;
			return resul;
		}
			
		public void actionPerformed(ActionEvent E)
		{
			String Token="###",Message;
			
			if(E.getActionCommand().equals("Send"))
			{
				try
				{
					if(!writeComplete())
					{
						JOptionPane.showMessageDialog(null,"Please, write correct and complete");
						return;
					}
					
					
					Socket MSG = new Socket(HostServer,PortServer);
					BufferedReader Reply = new BufferedReader (new InputStreamReader (MSG.getInputStream()));
					PrintWriter Send = new PrintWriter(new OutputStreamWriter(MSG.getOutputStream()));
					
					
					try
					{
						String pass = new String(Password.getPassword());
						Message = "NewUser"+Token+
								Login.getText()+Token+
								Email.getText()+Token+
								Name.getText()+Token+
								pass+Token+
								City.getText()+Token+
								Info.getText();
						
					}
					catch(Exception M)
					{
						JOptionPane.showMessageDialog(null,"Write correct ?");
						return;
					}
					
					try
					{
						Send.println(Message);
						Send.flush();
					}
				
					catch(Exception S)
					{
						JOptionPane.showMessageDialog(null,"Error send, verify the server");
						return;
					}
					
					try
					{
						String id = Reply.readLine();
						jFrame.setVisible(false);
						JOptionPane.showMessageDialog(null,"\nUser added, id number: "+id+"\n");
						jFrame.dispose();
						LoginUsuario L = new LoginUsuario();//HostServer,PortServer,PortClient);
						L.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
					}
					catch(Exception Insert)
					{
						JOptionPane.showMessageDialog(null,"Error, insert");
					}
					
					Reply.close();
					Send.close();
					Send = null;
					MSG.close();
					MSG = null;
					
				}
				catch(Exception SOCKET)
				{
					JOptionPane.showMessageDialog(null,"Error in conect to server: [ "+HostServer+" : "+PortServer+" ]");
				}
			}
			
			if(E.getActionCommand().equals("Cancel"))
			{
				LoginUsuario L = new LoginUsuario();//HostServer,PortServer,PortClient);
				jFrame.dispose();
				
			}
		}
	}
}


class ClientMain extends Thread
{
	private JFrame jFrame;
	private JButton InformacoesUsuario, SearchUser, LabelOnline;
	private JLabel LabelLastAccess;
	private JPanel Main, Buttons, LIST, USERS;
	private JScrollPane UsersScroll;
	private JComboBox jComboStatus;
	
	private String HostServer, Token="###", UsuarioSenha;
	private int PortServer, PortClient, UsuarioID, STATUS=0;
	
	private Socket MSG;
	private BufferedReader Reply;
	private PrintWriter Send;
	
	private MOUSEClick MOUSE;
	private MouseListener mouseListener;
		
	private Vector  ContactListId = new Vector(),
			ContactListLogin = new Vector(),
			ContactListIp = new Vector(),
			MessageList = new Vector();
				
		
	static ImageIcon iconOnline = new ImageIcon("openchat/client/icons/online.png");
	static ImageIcon iconOffline = new ImageIcon("openchat/client/icons/offline.png");
	static ImageIcon iconMessage = new ImageIcon("openchat/client/icons/message.png");
	static ImageIcon iconFind = new ImageIcon("openchat/client/icons/url.png");
	static ImageIcon iconInfo = new ImageIcon("openchat/client/icons/chat.png");
	static ImageIcon iconAdd = new ImageIcon("openchat/client/icons/gnomeicu-ffc.png");
	static ImageIcon iconRem = new ImageIcon("openchat/client/icons/gnomeicu-occ.png");
	static ImageIcon iconSearch = new ImageIcon("openchat/client/icons/gnomeicu-url.png");
	static ImageIcon iconMy = new ImageIcon("openchat/client/icons/gnomeicu-file.png");
	static ImageIcon iconAbout = new ImageIcon("openchat/client/icons/gnomeicu-offline.png");
	static ImageIcon iconExit = new ImageIcon("openchat/client/icons/gnomeicu-dnd.png");
	static ImageIcon iconSend = new ImageIcon("openchat/client/icons/gnomeicu-ok.png");
	static ImageIcon iconClose = new ImageIcon("openchat/client/icons/gnomeicu-cancel.png");
	
	public ClientMain(String HS, int PS, int PC, int Id, String UsuarioSenha)
	{
		this.HostServer = new String(HS);
		this.PortServer = PS;
		this.PortClient = PC;
		this.UsuarioID = Id;
		this.UsuarioSenha = UsuarioSenha;
	}
	
	public void run()
	{
		jFrame =  new JFrame();
		
		Main = new JPanel(new BorderLayout());
		Buttons = new JPanel(new GridLayout(3,1));
						
		LIST = new JPanel(new GridLayout(0, 1, 0, 5));
		USERS = new JPanel(new BorderLayout(2,5));
		
		USERS.add(LIST,BorderLayout.PAGE_START);
					
		UsersScroll = new JScrollPane(LIST);
		UsersScroll.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		USERS.add("North", LIST);
		
		MOUSE = new MOUSEClick();
		GetListContact();	//get contact list, if 1 get online users, 0 get all users
		
		LabelOnline = new JButton("Online");
		LabelLastAccess = new JLabel("");
		
		SearchUser = new JButton("Search for User", iconSearch);
		InformacoesUsuario = new JButton("Info User", iconInfo);
	
		String jStatus[] = { "All Users", "Online", "Offline"};
		jComboStatus = new JComboBox(jStatus);
		
		jComboStatus.addItemListener(new ItemListener()
		{
			public void itemStateChanged(ItemEvent StatusEvent)
			{
				if(StatusEvent.getStateChange()==ItemEvent.SELECTED)
				{
					STATUS = jComboStatus.getSelectedIndex();
					GetListContact();
				}
			}
		}
		);
		
		Buttons.add(jComboStatus);		
		Buttons.add(InformacoesUsuario);
		Buttons.add(SearchUser);
		
		ButtonHandler handler = new ButtonHandler();
		InformacoesUsuario.addActionListener(handler);
		SearchUser.addActionListener(handler);
				
		JMenu Menu = new JMenu("Options");
		Menu.setMnemonic('O');
		
		JMenu Exit = new JMenu("Exit");
		Menu.setMnemonic('E');

		JMenuItem AddContact = new JMenuItem("Add Contact",iconAdd);
		JMenuItem RemContact = new JMenuItem("Remove Contact", iconRem);
		JMenuItem InformacoesUsuario = new JMenuItem("Info User", iconInfo);
		JMenuItem SearchUser = new JMenuItem("Search for User", iconSearch);
		JMenuItem MyInfo = new JMenuItem("My Info", iconMy);
		JMenuItem About = new JMenuItem("About", iconAbout);
		JMenuItem exit = new JMenuItem("Exit", iconExit);
		//JMenuItem Logout = new JMenuItem("Logout");
				
		//Exit.add(Logout);
		Exit.addSeparator();
		Exit.add(exit);
		
		Menu.add(AddContact);
		Menu.add(RemContact);
		Menu.add(InformacoesUsuario);
		Menu.add(SearchUser);
		Menu.addSeparator();
		Menu.add(MyInfo);
		Menu.addSeparator();
		Menu.add(About);
		
		ClickMenuItems clickMenu = new ClickMenuItems();
		
		InformacoesUsuario.addActionListener(clickMenu);
		exit.addActionListener(clickMenu);
		AddContact.addActionListener(clickMenu);
		RemContact.addActionListener(clickMenu);
		SearchUser.addActionListener(clickMenu);
		About.addActionListener(clickMenu);
		//Logout.addActionListener(clickMenu);
		MyInfo.addActionListener(clickMenu);
		
		JMenuBar bar = new JMenuBar();
		jFrame.setJMenuBar(bar);
		
		bar.add(Menu);
		bar.add(Exit);
		
		Main.add(LabelOnline,BorderLayout.PAGE_START);
		Main.add(new JScrollPane(USERS),BorderLayout.CENTER);
		Main.add(Buttons,BorderLayout.PAGE_END);
				
		jFrame.getContentPane().add(Main);
			
		jFrame.setTitle(UsuarioID+" - OpenChat");
		jFrame.setLocation(844,132);
		jFrame.setSize(170,500);
		jFrame.setVisible(true);
		jFrame.show();
				
		jFrame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		//jFrame.setDefaultLookAndFeelDecorated(true);
		new StartInbox(PortClient).start();
	}
		
	public String ContatoUsuario(String option, int Contact)
	{
		String Cont="false";
		try
		{
			MSG = new Socket(HostServer,PortServer);
			Send = new PrintWriter(new OutputStreamWriter(MSG.getOutputStream()));
			Reply = new BufferedReader (new InputStreamReader (MSG.getInputStream()));
			
			Send.println(option+Token+UsuarioID+Token+Contact+Token);
			Send.flush();
			
			Cont =  Reply.readLine();
			
			Send.close();
			Reply.close();
			MSG.close();
		}				
		catch(Exception Exit)
		{
			JOptionPane.showMessageDialog(null,"Server down!\n\n"+Exit.getMessage());
		}
		return Cont;
	}
	
	public void Logout()
	{
		try
		{
			MSG = new Socket(HostServer,PortServer);
			Send = new PrintWriter(new OutputStreamWriter(MSG.getOutputStream()));
			
			Send.println("Logout"+Token+UsuarioID+Token+UsuarioSenha+Token);
			Send.flush();
			MSG.close();
			Send.close();
			
			ContactListId.clear();
			ContactListLogin.clear();
			ContactListIp.clear();
			LIST.removeAll();
			LIST.revalidate();
			
		}				
		catch(Exception Exit)
		{
			JOptionPane.showMessageDialog(null,"Error :: Server offline or password is bad.\n\n"+Exit.getMessage());
		}
	}
	
	public class ClickMenuItems implements ActionListener
	{
			public void actionPerformed(ActionEvent E)
			{
				if(E.getActionCommand().equals("About"))
				{
					About A = new About();
				}
					
				if(E.getActionCommand().equals("Logout"))
				{
					Logout();
				}
					
				if(E.getActionCommand().equals("Exit"))
				{
					Logout();
					System.exit(0);
				}
				if(E.getActionCommand().equals("My Info"))
				{
					boolean op=true;
					new InformacoesUsuario(HostServer, PortServer, ""+UsuarioID,op).start();
				}
				if(E.getActionCommand().equals("Info User"))
				{
					if(LabelLastAccess.getText().equals(""))
					{
						JOptionPane.showMessageDialog(null,"\nSelect the User Contact.");
					}
						else
					for(int i=0; i < ContactListId.size(); i++)
					{
						
						if(ContactListLogin.get(i).equals(LabelLastAccess.getText()))
						{
							boolean op=false;
							new InformacoesUsuario(HostServer, PortServer, ""+ContactListId.get(i),op).start();
							break;
						}
					}
				}
				if(E.getActionCommand().equals("Add Contact"))
				{
					int NewUser=0;
					
					try
					{
						String test = JOptionPane.showInputDialog("What is ID of the New Contact User ?");
						if(test==null)
							return;
						else
							NewUser = Integer.parseInt(test);
					}
					catch(Exception NEWUSER)
					{
						JOptionPane.showMessageDialog(null,"\nThe value of ID is invalid. (only integer)\n");
						return;
					}
					
					if(ContatoUsuario("AddContact",NewUser).equals("true"))
					{
						JOptionPane.showMessageDialog(null,"\n Contact User added !");
						GetListContact();
					}
					else
						JOptionPane.showMessageDialog(null,"\n Contact: \n    - Not found\n    - Contact exist");
				}
				
				if(E.getActionCommand().equals("Remove Contact"))
				{
					int RemUser=0, ConfirmRem=0;
					
					if(LabelLastAccess.getText().equals(""))
					{
						JOptionPane.showMessageDialog(null,"\nSelect the User Contact.");
					}
					else
					{
						RemUser = JOptionPane.showConfirmDialog((Component)null, "Remove the user :  "+ LabelLastAccess.getText(), "Remove Uset - OpenChat", JOptionPane.YES_NO_OPTION);
						
						if(RemUser!=1)
						{
							for (int i=0; i < ContactListLogin.size(); i++)
							{
								if ((LabelLastAccess.getText()).equals(ContactListLogin.get(i)))
								{
									RemUser=Integer.parseInt(""+ContactListId.get(i));
									break;
								}
							}

							if(ContatoUsuario("DeleteContact",RemUser).equals("true"))
							{
								JOptionPane.showMessageDialog(null,"\n Contact User removed !");
								GetListContact();
								LabelLastAccess.setText("");
							}
							else
								JOptionPane.showMessageDialog(null,"\n Contact: \n    - Not found\n    - Contact exist");
						}
					}
				}
				if(E.getActionCommand().equals("Search for User"))
					new SearchUsers().start();
			}
	}
		
	private void GetListContact()
	{
		StringTokenizer CONTACT;
		try
		{
			MSG = new Socket(HostServer,PortServer);
			Reply = new BufferedReader (new InputStreamReader (MSG.getInputStream()));
			Send = new PrintWriter(new OutputStreamWriter(MSG.getOutputStream()));
		
			String Message = "ReturnContactList"+Token+UsuarioID;
				
			Send.println(Message);
			Send.flush();
				
			CONTACT = new StringTokenizer(Reply.readLine(),Token);
							
			MSG.close();
			MSG=null;
			Reply.close();
			Reply=null;
			Send.close();
			Send=null;
			
			if(CONTACT.nextToken().equals("ContactList"))
			try
			{				
				ContactListId.clear();
				ContactListLogin.clear();
				ContactListIp.clear();
				
				ContactListIp.removeAllElements();
				ContactListLogin.removeAllElements();
				ContactListId.removeAllElements();
				
				LIST.removeAll();
				LIST.revalidate();
				
				String LOGIN, ID, Ip;
				
				while (CONTACT.hasMoreTokens())
				{
				
					ID = new String(CONTACT.nextToken());
					LOGIN = new String(CONTACT.nextToken());
					Ip = new String(CONTACT.nextToken());
					CONTACT.nextToken(); //not port
					ContactListId.addElement(ID);
					ContactListLogin.addElement(LOGIN);
					ContactListIp.addElement(Ip);
					
					if(STATUS==1 || STATUS==0)
					if(! Ip.equals("0")) //online
					{
						JLabel label = new JLabel(LOGIN, iconOnline, JLabel.LEFT);
						LIST.add("Center",label);
						label.addMouseListener(MOUSE);
						label.addMouseListener(mouseListener);
						
					}
					
					if(STATUS==2 || STATUS==0)
					if(Ip.equals("0")) //offline
					{							
						JLabel label = new JLabel(LOGIN, iconOffline, JLabel.LEFT);
						LIST.add("Center",label);
						label.addMouseListener(MOUSE);
						label.addMouseListener(mouseListener);
					}
				}
			}
			catch(Exception E)
			{
				JOptionPane.showMessageDialog(null,"Error in ContactList.\n\n"+E.getMessage());
				return;
			}
		}
		catch(Exception E)
		{
			JOptionPane.showMessageDialog(null,"Error in ContactList.\n\n"+E.getMessage());
			return;
		}
		
	}
	
	class MOUSEClick extends MouseAdapter
	{
		public void mouseClicked(MouseEvent e) 
		{
			if (!LabelLastAccess.equals("")) {
				LabelLastAccess.setForeground(Color.BLACK);
			}
			
			JLabel pressedLabel = (JLabel) e.getComponent();
			LabelLastAccess = pressedLabel;
			//System.out.println(pressedLabel.getComponent());
			
			String PoupMessage = new String("");
			int IdFROM=0;
			
			// essa parte aqui �bugada, pois se tiver 2 contatos com o mesmo nome, ele vai pegar o primeiro da lista
			// msm pesquisando no site da sun e em grupos nao consegui resolver isso
			// deve haver uma maneira mais inteligente, alias, existe, porem eu nao sei 
			for (int i=0; i < ContactListLogin.size(); i++)
			//for (int i=0; i < LIST.getComponentCount(); i++)
			{
				if (pressedLabel.getText().equals(ContactListLogin.get(i)) && e.getClickCount() == 2)
				//if (ContactListLogin.get(i) && e.getClickCount() == 2)
				{
					if(pressedLabel.getIcon()==iconMessage)
					{
						pressedLabel.setIcon(iconOnline);
						
						for(int k=0; k < MessageList.size(); k++)
						for(int j=0; j < MessageList.size(); j++)
						{
							if( ("MessageTo"+Token+ContactListId.get(i)).equals(MessageList.get(j)))
							{
								IdFROM = i;
								MessageList.removeElementAt(j);
								PoupMessage = PoupMessage+MessageList.get(j)+Token;
								MessageList.removeElementAt(j);
								k=0;
								break;
								
							}					
						}
						new MsgBoxReceive(Integer.parseInt(""+ContactListId.get(IdFROM)),""+ContactListLogin.get(IdFROM),""+ContactListIp.get(IdFROM),PoupMessage).start();
					}
					else
					{
						pressedLabel.setForeground(Color.BLACK);
						pressedLabel.repaint();
						new MsgBox(HostServer, PortServer, UsuarioID, ContactListId.get(i), ContactListLogin.get(i), ContactListIp.get(i)).start();
					}
					break;
				}
				else
				if(pressedLabel.getText().equals(ContactListLogin.get(i)) && e.getClickCount() == 1)
				{
					pressedLabel.setForeground(Color.BLUE);
					pressedLabel.repaint();
				}
			}
		}
	}
	
	
	class ButtonHandler implements ActionListener
	{
		public void actionPerformed(ActionEvent E)
		{
			if(E.getActionCommand().equals("Info User"))
			{
				if(LabelLastAccess.getText().equals(""))
				{
					JOptionPane.showMessageDialog(null,"\nSelect the User Contact.");
					
				}
				else
				for(int i=0; i < ContactListId.size(); i++)
				{
					if(ContactListLogin.get(i).equals(LabelLastAccess.getText()))
					{
						boolean op=false;
						new InformacoesUsuario(HostServer, PortServer, ""+ContactListId.get(i),op).start();
						break;
					}
				}
					
			}
			if(E.getActionCommand().equals("Search for User"))
			{
				new SearchUsers().start();
			}	
		}
	}
		
	
	
	class StartInbox extends Thread
	{
		private ServerSocket ServerMessage;
		private Socket Inbox;
		private StringTokenizer MSG;
		private BufferedReader E;
		private String Confirm;
		private int IdFrom, PortClient;
		private ClientMain clientMain;
		
		public StartInbox(int PortClient)
		{
			this.PortClient = PortClient;
		}
		public void run()
		{
			//System.out.println("\n\tEstado: [escutando na porta " + PortClient + "]");
			
			try
			{
				ServerSocket ServerMessage = new ServerSocket(PortClient);
			
				for(;;)
				{
					Socket Inbox = ServerMessage.accept();
					NewMessage(Inbox);
				}
			}
			catch(Exception E)
			{
				System.err.println("Erro: canal de comunicacao::CLIENTEOPENCHAT");
			}
		}
	
		private void NewMessage(Socket New)
		{
			try
			{
				JLabel LabelUser = new JLabel();
				
				this.Inbox = New;
				E = new BufferedReader (new InputStreamReader (this.Inbox.getInputStream()));
				MSG = new StringTokenizer (E.readLine (),"###");
			
				Confirm = new String(MSG.nextToken());
				
				if(Confirm.equals("UpdateList"))
					GetListContact();
				
				if(Confirm.equals("NewMessage"))
				{
					IdFrom = Integer.parseInt(MSG.nextToken());
					
					String Msg = "";
			
					try{
					for (;;)
					{
						Msg = Msg + E.readLine();
						if(E.ready())
							Msg = Msg + '\n';
						else
							break; // caso nao existam, sair do loop de montagem da mensagem
					}
				}
					catch(Exception E)
					{
						System.out.println("ERRO NO FOR CLIENT :"+E.getMessage());
					}
					//System.out.println("CLIENT :: "+Msg);
					int flag=0;
					for(int i=0; i< LIST.getComponentCount(); i++)
					{
						if(Integer.parseInt(""+ContactListId.get(i))==IdFrom)
						{
							LabelUser = (JLabel) LIST.getComponent(i);
							LabelUser.setForeground(Color.BLUE);
							LabelUser.repaint();
							LabelUser.setIcon(iconMessage);
													
							MessageList.addElement("MessageTo"+Token+IdFrom);
							MessageList.addElement(Msg);
							flag=1;
							break;
						}
					}
					if(flag==0)
						new MsgBoxReceive(IdFrom, new String(""+IdFrom), Inbox.getInetAddress().getHostAddress(), Msg).start();
				}
			}
			catch(Exception E)
			{
				System.out.println("errrooooo");
				System.out.println(E.getMessage());
			}
			
			try
			{
				E.close ();
				Inbox.close ();
			}
			catch(Exception E)
			{
				System.out.println("erro ao close do client");
			}
		}
	}
	
	class SearchUsers extends Thread
	{
		private JFrame jFrame;
		private JPanel jPanel, jButtons, jLists, jLabels;
		private JButton ButtonSearch, ButtonClose, ButtonAdd;
		private JLabel LabelId, LabelLogin, LabelIp, LabelSearch;
		private JList ListId, ListLogin, ListIp;
		private JComboBox ComboSearchFor;
		
		private String jComboSearchOptions[] = { "All Users", "Online Users"}, Token="###";
		private StringTokenizer UsersFound;
		private int OptionSearch=0;
			
		private Vector UsuarioIDFound, LoginUsuarioFound, UserIpFound;
				
		public void run()
		{
			jFrame = new JFrame();
			
			jPanel = new JPanel(new BorderLayout());
			jLists = new JPanel(new GridLayout(1,3));
			jButtons = new JPanel( new GridLayout(1,3));
			jLabels = new JPanel(new GridLayout(2,3));
		
			ButtonSearch = new JButton("Search now", iconSend);
			ButtonClose = new JButton("Close", iconClose);
			ButtonAdd = new JButton("Add to list", iconAdd);
			jButtons.add(ButtonSearch);
			jButtons.add(ButtonAdd);
			jButtons.add(ButtonClose);
			
			ButtonClickSearch Search = new ButtonClickSearch();
			ButtonSearch.addActionListener(Search);
			ButtonClose.addActionListener(Search);
			ButtonAdd.addActionListener(Search);
			
			
			ComboSearchFor = new JComboBox(jComboSearchOptions);
			
			ComboSearchFor.addItemListener(new ItemListener()
			{
				public void itemStateChanged(ItemEvent StatusEvent)
				{
					if(StatusEvent.getStateChange()==ItemEvent.SELECTED)
						OptionSearch = ComboSearchFor.getSelectedIndex();
				}
			}
			);
		
			LabelSearch = new JLabel("User Search", JLabel.CENTER);
			LabelSearch.setForeground(Color.BLUE);
			LabelId = new JLabel("  Id  ( select here )");
			LabelLogin = new JLabel("  Nick");
			LabelIp = new JLabel("  Ip");
						
			jLabels.add(new JLabel(""));
			jLabels.add(LabelSearch);
			jLabels.add(ComboSearchFor);
			
			jLabels.add(LabelId);
			jLabels.add(LabelLogin);
			jLabels.add(LabelIp);
			
			ListId = new JList();
			ListLogin = new JList();
			ListIp = new JList();
			jLists.add(ListId);
			jLists.add(ListLogin);
			jLists.add(ListIp);
			
			ItemSelect itemSelect = new ItemSelect();
			
			
			ListId.addListSelectionListener(itemSelect);
			ListIp.addListSelectionListener(itemSelect);
			ListLogin.addListSelectionListener(itemSelect);
			
			
			jPanel.add(jLabels,BorderLayout.PAGE_START);
			jPanel.add(new JScrollPane(jLists),BorderLayout.CENTER);
			jPanel.add(jButtons,BorderLayout.PAGE_END);
			
			jFrame.getContentPane().add(jPanel);
		
			jFrame.setTitle("Search for User - OpenChat");
			jFrame.setLocation(200,259);
			jFrame.setSize(600,250);
			jFrame.setVisible(true);
			jFrame.show();
			jFrame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		}
		
		class ItemSelect implements ListSelectionListener
		{
			public void valueChanged(ListSelectionEvent EventList)
			{
				if(!ListId.isSelectionEmpty())
				{
					ListLogin.setSelectedIndex(ListId.getSelectedIndex());
					ListIp.setSelectedIndex(ListId.getSelectedIndex());
				}
				else
				if(!ListLogin.isSelectionEmpty() || !ListIp.isSelectionEmpty())
				{
					ListLogin.clearSelection();
					ListIp.clearSelection();
				}
			}
		}
		
		
		class ButtonClickSearch implements ActionListener
		{
			public void actionPerformed(ActionEvent ESearch)
			{
				if(ESearch.getActionCommand().equals("Search now"))
				{
					SearchNowUsers();
				
				}
				if(ESearch.getActionCommand().equals("Close"))
					jFrame.dispose();
				
				if(ESearch.getActionCommand().equals("Add to list"))
				{
					if(ListId.isSelectionEmpty())
						JOptionPane.showMessageDialog(null,"\n Select the Id of contact.");
					else
					if(ContatoUsuario("AddContact",Integer.parseInt(""+UsuarioIDFound.get(ListId.getSelectedIndex()))).equals("true"))
					{
						JOptionPane.showMessageDialog(null,"\n Contact User added !");
						GetListContact();
					}
					else
						JOptionPane.showMessageDialog(null,"\n Contact exist in you list.");
				}
			}
		}
		
		private void SearchNowUsers()
		{
			try
			{
				MSG = new Socket(HostServer,PortServer);
				Reply = new BufferedReader (new InputStreamReader (MSG.getInputStream()));
				Send = new PrintWriter (new OutputStreamWriter(MSG.getOutputStream()));
			
			try
			{
				String M = "ReturnUsers"+Token+OptionSearch+Token;
				Send.println(M);
				Send.flush();
				
				UsersFound = new StringTokenizer(Reply.readLine(), Token);
				UsuarioIDFound = new Vector();
				UserIpFound = new Vector();
				LoginUsuarioFound = new Vector();
				
				UsersFound.nextToken();
				
				String U,I,L;
				
				while (UsersFound.hasMoreTokens())
				{
					U=new String(UsersFound.nextToken());
					L=new String(UsersFound.nextToken());
					I=new String(UsersFound.nextToken());
					UsersFound.nextToken();
					
					if(L.length() > 25)
						L = L.substring(0,25)+"...";
					
					UsuarioIDFound.addElement(U);
					LoginUsuarioFound.addElement(L);
					UserIpFound.addElement(I);
				
					
				}
				ListId.clearSelection();
				ListLogin.clearSelection();
				ListIp.clearSelection();
				ListId.setListData(UsuarioIDFound);
				ListLogin.setListData(LoginUsuarioFound);
				ListIp.setListData(UserIpFound);
				
				
			}
			catch(Exception E)
			{
				System.out.println("erro ao procurar nego"+E.getMessage());
			}
			
			
				Reply.close();
				Send.close();
				MSG.close();
			}
			catch(Exception Ex)
			{
				JOptionPane.showMessageDialog(null,"\nError in communication with server!\nServer online?","Warning",JOptionPane.WARNING_MESSAGE);
				return;
			}
			
		}
			
	}
	
	
		
}


class InformacoesUsuario extends Thread
{     
	private JPanel Register, L, R, E;
	private JButton ButtonClose, ButtonUpdate;
	private JFrame jFrame;
	private JLabel LabelInfo, Label_Id, Label_Login, Label_Name, Label_Email, Label_City, Label_Info, Label_Password, lId;
	private JTextField Login, Name, Email, City, Info, Password;
	private int Id, Port;
	private String Token="###", Host;
	private boolean option=false;
		
	private BufferedReader Receive;
	private PrintWriter Send;
	private Socket Msg;
	
	static ImageIcon iconUpdate = new ImageIcon("openchat/client/icons/gnomeicu-ok.png");
	static ImageIcon iconClose = new ImageIcon("openchat/client/icons/gnomeicu-cancel.png");
	
	public InformacoesUsuario(String Host, int Port, String Id, boolean option)
	{
		this.Id = Integer.parseInt(Id);
		this.Host = Host;
		this.Port = Port;		
		this.option=option;
		
		try
		{
			Msg = new Socket(Host,Port);
			Receive = new BufferedReader (new InputStreamReader (this.Msg.getInputStream()));
			Send = new PrintWriter (new OutputStreamWriter(this.Msg.getOutputStream()));
		}
		catch(Exception Ex)
		{
			JOptionPane.showMessageDialog(null,"\nError in communication with server!\nServer online?","Warning",JOptionPane.WARNING_MESSAGE);
			return;
		}
	}
	
	public void run()
	{
		jFrame = new JFrame();
		Register = new JPanel();
		L = new JPanel();
		R = new JPanel();
		E = new JPanel();
		
		Register.setLayout(new BorderLayout());
		L.setLayout(new GridLayout(8,1));
		R.setLayout(new GridLayout(8,1));
		E.setLayout(new GridLayout(1,2));
		
		Register.add(L,BorderLayout.LINE_START);
		Register.add(R,BorderLayout.CENTER);
		Register.add(E,BorderLayout.PAGE_END);
		
		LabelInfo = new JLabel("USER INFORMATION",JLabel.CENTER);
		LabelInfo.setForeground(Color.BLUE);
		
		Register.add(LabelInfo,BorderLayout.PAGE_START);
		
		lId = new JLabel(""+Id, JLabel.LEFT);
		Label_Id = new JLabel(" Id ",JLabel.LEFT);
		Label_Login = new JLabel(" Nick",JLabel.LEFT);
		Label_Name = new JLabel (" Name",JLabel.LEFT);
		Label_Email = new JLabel(" Email",JLabel.LEFT);
		Label_City = new JLabel (" City",JLabel.LEFT);
		Label_Info = new JLabel (" Info",JLabel.LEFT);
		Label_Password = new JLabel(" Password  ",JLabel.LEFT);
		Label_Password.setVisible(option);
				
		try{
			Send.println("ReturnUserContactInformation"+Token+Id);
		
			Send.flush();
			
			StringTokenizer Information = new StringTokenizer(Receive.readLine(),Token);

			Login = new JTextField(Information.nextToken(),20);
			Login.setEditable(option);
			
			Email = new JTextField(Information.nextToken(),50);
			Email.setEditable(option);
				
			City = new JTextField(Information.nextToken(),30);
			City.setEditable(option);
				
			Name = new JTextField(Information.nextToken(),100);
			Name.setEditable(option);
				
			Info = new JTextField(Information.nextToken(),100);
			Info.setEditable(option);
				
			Password = new JPasswordField();//E.readLine());
			Password.setVisible(option);
						
			Send.close();
			Receive.close();
			Msg.close();
		}
		
		catch(Exception Ex)
		{
			JOptionPane.showMessageDialog(null,"Error in get Contact Information!\nServer online?","Warning",JOptionPane.WARNING_MESSAGE);
			return;
		}
		
		ButtonUpdate = new JButton("Update", iconUpdate);
		ButtonUpdate.setVisible(option);
		ButtonClose = new JButton("Close", iconClose);
		
		lId.setForeground(Color.BLUE);
		
		L.add(Label_Id);
		L.add(Label_Login);
		L.add(Label_Password);
		L.add(Label_Name);
		L.add(Label_Email);
		L.add(Label_City);
		L.add(Label_Info);
		
		R.add(lId);
		R.add(Login);
		R.add(Password);
		R.add(Name);
		R.add(Email);
		R.add(City);
		R.add(Info);
		
		E.add(ButtonUpdate);
		E.add(ButtonClose);
		
		ButtonHandler handler = new ButtonHandler();
		ButtonClose.addActionListener(handler);
		ButtonUpdate.addActionListener(handler);
				
		jFrame.getContentPane().add(Register);
		
		jFrame.setTitle("Info User - OpenChat");
		jFrame.setResizable(false);
		jFrame.setLocation(312,289);
		jFrame.setSize(400,210);
		jFrame.setVisible(true);
		jFrame.show();
		jFrame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		
	}
	public class ButtonHandler implements ActionListener
	{
		public void actionPerformed(ActionEvent E)
		{
			if(E.getActionCommand().equals("Close"))
			{
				jFrame.dispose();
			}
			else
			if(writeComplete())
			{
				
				try{
				Socket MSG = new Socket(Host,Port);
				BufferedReader Reply = new BufferedReader (new InputStreamReader (MSG.getInputStream()));
				PrintWriter Send = new PrintWriter(new OutputStreamWriter(MSG.getOutputStream()));
				
				
				String M = "UpdateUser"+Token+Id+Token+
					Password.getText()+Token+
					Login.getText()+Token+
					Email.getText()+Token+
					Name.getText()+Token+
					City.getText()+Token+
					Info.getText()+Token;
				//System.out.println(M);
				Send.println(M);
				Send.flush();
				
				if(Reply.readLine().equals("true"))
				{
					JOptionPane.showMessageDialog(null,"Update !");
					jFrame.dispose();
				}
				MSG.close();
				Reply.close();
				Send.close();
				
				}
				catch(Exception Es)
				{}
			}
			else
				JOptionPane.showMessageDialog(null,"Error in Update Contact Information!\nServer online? \n - Write Complet?","Warning",JOptionPane.WARNING_MESSAGE);
		}
	}
	
	private boolean writeComplete()
	{
			boolean resul = true;
			
			if(Login.getText().length()==0)
				resul=false;
			if(Email.getText().length()==0)
				resul=false;
			if(Name.getText().length()==0)
				resul=false;
			if(City.getText().length()==0)
				resul=false;
			if(Info.getText().length()==0)
				resul=false;
			if(Password.getText().length()==0)
				resul=false;
			return resul;
	}
}
class MsgBoxReceive extends Thread
{     
	private JPanel jPanel, jTop, jButtons;
	private JTextArea jTextArea;
	private JButton ButtonNext, ButtonClose;
	private JLabel LabelStatus;
	private JFrame jFrame;
	
	private StringTokenizer sTokenizer;
	private String Message, IpFrom, LoginFrom, Token="###";
	private int IdFrom, Amount=0;
	
	static ImageIcon iconNext = new ImageIcon("openchat/client/icons/gnomeicu-ok.png");
	static ImageIcon iconClose = new ImageIcon("openchat/client/icons/gnomeicu-cancel.png");
	
	public MsgBoxReceive(int IdFrom, String LoginFrom, String IpFrom, String Message)
	{
		this.IdFrom = IdFrom;
		this.LoginFrom = LoginFrom;
		this.Message = Message;
		this.IpFrom = IpFrom;
	}
	
	public void run()
	{
		
		jFrame = new JFrame();
		jFrame.setTitle(LoginFrom +" - OpenChat");

		jPanel = new JPanel(new BorderLayout(0,0));
		jTop = new JPanel(new GridLayout(2,1));
		jButtons = new JPanel(new GridLayout(1,2));
		
		ButtonNext = new JButton(iconNext);
		ButtonClose = new JButton("Close", iconClose);
		
		jTextArea = new JTextArea(ReadMessage(),5,20);
		jTextArea.setEditable(false);
		jTextArea.setBackground(Color.LIGHT_GRAY);
				
		LabelStatus = new JLabel(" Message from "+LoginFrom+"     Id: "+IdFrom+"     Ip Address: "+IpFrom);
				
		jTop.add(LabelStatus);
				
		jButtons.add(ButtonNext, iconNext);
		jButtons.add(ButtonClose, iconClose);
		
		ButtonHandler handler = new ButtonHandler();
		ButtonNext.addActionListener(handler);
		ButtonClose.addActionListener(handler);
				
		jPanel.add(jTop, BorderLayout.PAGE_START);
		jPanel.add(new JScrollPane(jTextArea), BorderLayout.CENTER);
		jPanel.add(jButtons, BorderLayout.PAGE_END);
		
		jFrame.getContentPane().add(jPanel);
		
		jFrame.setLocation(300,300);
		jFrame.setSize(400,200);
		jFrame.setVisible(true);
		jFrame.show();
				
	}
	
	private String ReadMessage()
	{
		if(Amount==0)	//not initilized
		{
			sTokenizer = new StringTokenizer(Message,Token);
			Amount = sTokenizer.countTokens();
			Amount--;
			
			if(Amount==0)
			{	
				ButtonNext.setVisible(false);
				Amount=0;
			}
			else
				ButtonNext.setText("Next - "+Amount);
			
		}
		return sTokenizer.nextToken();
	}
	
	private class ButtonHandler implements ActionListener
	{
		public void actionPerformed(ActionEvent E)
		{
			
			if(E.getActionCommand().equals("Next - "+Amount))
			{
				if(Amount > 0)
				{
					jTextArea.setText(ReadMessage());
					Amount--;
					
					if(Amount == 0)
						ButtonNext.setVisible(false);
					else
						ButtonNext.setText("Next - "+Amount);
				}
				else
					ButtonNext.setVisible(false);
			}
			if(E.getActionCommand().equals("Close"))
			{
				jFrame.dispose();
			}
		}
	}
}


// this class send message to user
class MsgBox extends Thread
{
	private JLabel LabelStatus;
	private JButton ButtonSend, ButtonCancel;
	private JPanel jPanel, jTop, jButtons;
	private JFrame jFrame;
	private JTextArea textArea;
	
	private String IpTo, LoginTo, HostServer, Token="###";
	private int IdFrom, IdTo, PortServer;
	
	static ImageIcon iconSend = new ImageIcon("openchat/client/icons/gnomeicu-ok.png");
	static ImageIcon iconCancel = new ImageIcon("openchat/client/icons/gnomeicu-cancel.png");
	
	public MsgBox(String HostServer, int PortServer, int IdFrom, Object IdTo, Object LoginTo, Object IpTo)
	{
		this.HostServer = HostServer;
		this.PortServer = PortServer;
		
		this.IdFrom = IdFrom;
		this.IdTo = Integer.parseInt(new String(""+IdTo));
		this.LoginTo = ""+LoginTo;
		this.IpTo = ""+IpTo;
	}
	
	public void run()
	{
		
		jFrame = new JFrame();
		jFrame.setTitle(LoginTo +" - OpenChat");

		jPanel = new JPanel(new BorderLayout(0,0));
		jTop = new JPanel(new GridLayout(2,1));
		jButtons = new JPanel(new GridLayout(1,2));
		
		ButtonSend = new JButton("Send", iconSend);
		ButtonCancel = new JButton("Cancel", iconCancel);
		
		
		LabelStatus = new JLabel(" Message to "+LoginTo+"     Id: "+IdTo+"     Ip Address: "+IpTo);
		
		textArea = new JTextArea(5,20);
									
		jTop.add(LabelStatus);
		
		
		jButtons.add(ButtonSend);
		jButtons.add(ButtonCancel);
		
		ButtonHandler handler = new ButtonHandler();
		ButtonSend.addActionListener(handler);
		ButtonCancel.addActionListener(handler);
				
		jPanel.add(jTop, BorderLayout.PAGE_START);
		jPanel.add(new JScrollPane(textArea), BorderLayout.CENTER);
		jPanel.add(jButtons, BorderLayout.PAGE_END);
		
		jFrame.getContentPane().add(jPanel);
		
		jFrame.setLocation(300,300);
		jFrame.setSize(400,200);
		jFrame.setVisible(true);
		jFrame.show();
				
	}
	
	public class ButtonHandler implements ActionListener
	{
		public void actionPerformed(ActionEvent E)
		{
			if(E.getActionCommand().equals("Send"))
			{
				if(textArea.getText().length() != 0)
				{
					textArea.setEditable(false);
					
					if(SendMessage().equals("false"))
					{
						JOptionPane.showMessageDialog(null,"Message not send.\n\n");
						textArea.setEditable(true);
					}
					else
					jFrame.dispose();
				}
			}
			if(E.getActionCommand().equals("Cancel"))
			{
				if(!textArea.isEditable())
					textArea.setEditable(true);
				else
					jFrame.dispose();
			}
		}
	}
	
	public String SendMessage()
	{
		String SEND="false";
		
		try
		{
			Socket MSG = new Socket(HostServer,PortServer);
			BufferedReader Reply = new BufferedReader (new InputStreamReader (MSG.getInputStream()));
			PrintWriter Send = new PrintWriter(new OutputStreamWriter(MSG.getOutputStream()));
				
			String M = "SendMessage"+Token+IdFrom+Token+IdTo+Token;
			//System.out.println(">>"+M);
			Send.println(M);
			Send.flush();
			
			Send.println(textArea.getText());
			Send.flush();
		
			SEND = Reply.readLine();
						
			MSG.close();
			Reply.close();
			Send.close();
			
		}
		catch(Exception Send)
		{
			JOptionPane.showMessageDialog(null,"Error send message.\n\n"+Send.getMessage());
			SEND="false";
		}
		return SEND;
	}
}
		
class About
{
	private JFrame jFrame;
	private JPanel jPanel, jAbout;
	private JButton ButtonOk;
	private JTextArea textAbout;
	private JLabel labelAbout, labelOpenChat;
		
	static ImageIcon iconLinux = new ImageIcon("icons/linux.jpg");
	static ImageIcon iconClose = new ImageIcon("openchat/client/icons/gnomeicu-cancel.png");
	
	public About()
	{
		jFrame = new JFrame();
		jPanel = new JPanel(new BorderLayout());
		jAbout = new JPanel(new FlowLayout());
		
		
		textAbout = new JTextArea("\n\nOpenChat version 0.1b   "+
					"\n\n Author: Cesar H. Kallas  "+
					"\n\n http://www.opensrc.co.nr  "+
					"\n opensrc@gmx.net"+
					"\n\n Gnu Public License (GPL)\n \n \n ");
		textAbout.setEditable(false);
		
		textAbout.setAlignmentX(JTextArea.CENTER_ALIGNMENT);
		
		textAbout.setBackground(Color.LIGHT_GRAY);
		
		labelOpenChat = new JLabel("OpenChat", JLabel.CENTER);
		labelAbout = new JLabel(iconLinux);
		
		ButtonOk = new JButton("Close", iconClose);
		
		jAbout.add(textAbout);
		jAbout.add(labelAbout);
		
		jPanel.add(labelOpenChat, BorderLayout.PAGE_START);
		jPanel.add(jAbout, BorderLayout.CENTER);
		jPanel.add(ButtonOk, BorderLayout.PAGE_END);
		
		ButtonHandler handler = new ButtonHandler();
		ButtonOk.addActionListener(handler);
		
		jFrame.getContentPane().add(jPanel);
		
		jFrame.setTitle("About - OpenChat");
		jFrame.setResizable(true);
		jFrame.setLocation(312,289);
		jFrame.setSize(300,300);
		jFrame.setVisible(true);
		jFrame.show();
		jFrame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
	}
	
	class ButtonHandler implements ActionListener
	{
		public void actionPerformed(ActionEvent E)
		{
			if(E.getActionCommand().equals("Close"))
			{
				jFrame.dispose();
			}
		}
	}
}
		
		
		
		
		
		
		
		
		
		
		
	
		



/*
   UinText.addKeyListener(new KeyAdapter() 
   {
    public void keyTyped(KeyEvent e) 
    {
     char c = e.getKeyChar();      
     if (!((Character.isDigit(c) || (c == KeyEvent.VK_BACK_SPACE) ||  (c == KeyEvent.VK_DELETE))) ){
       getToolkit().beep();
       e.consume();
     }
   }
 });
*/
